/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package block;

import game.Sprite;
import main.Global;
import score.Score;

/**
 * The moving wall is a wall that opens or closes with an interval of 5 seconds.
 * @author s070280
 */
public class MovingWall extends Block{
    /**
     * Constructor of movingwall sets defaults.
     * Sets openstate to closed, animation cycle to its initial value defined in Global class and sets the image.
     */
    public MovingWall() {
        openState = "closed";    
        animationCycle = Global.MOVINGWALLTIME.value();
        setImage(this.getClass().getSimpleName().toLowerCase() + "_" + openState);
    }    
    
    
    /**
     * Changes state of moving wall from closed to open and vice versa when the timer runs out.
     */
    public void animateWall() {
        animationCycle--;
        if (animationCycle == 0) {
            openState = openState.equals("closed") ? "open" : "closed";
            animationCycle = Global.MOVINGWALLTIME.value();
            setImage(this.getClass().getSimpleName().toLowerCase() + "_" + openState);
        }
    }
    
    /**
     * Get the effect of moving wall on a sprite. When the wall is open, let sprite pass(return true)
     * and when moving wall is closed, do not let sprite pass(return false).
     * 
     * @param sprite derived from superclass block, does not have any uses here.
     * @return boolean true=pass, false=block 
     */
    @Override
    public Boolean getEffect(Sprite sprite, Score score) {
        if (openState.equals("open")) {
            return true;
        } else {
            return false;
        }
    }   
    
    @Override
    public Boolean getEffect(Sprite sprite) {
        if (openState.equals("open")) {
            return true;
        } else {
            return false;
        }
    } 
      
    private String openState;
    private int animationCycle;    
}
