/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package block;

import game.Ghost;
import game.PacMan;
import game.Sprite;
import game.Level;
import score.Score;

/**
 *
 * @author s070280
 */
public class Spawn extends Block {  
    public Spawn(String typeName){
        spawnType = SpawnType.valueOf(typeName.toUpperCase());
        setImage(this.getClass().getSimpleName().toLowerCase() + "_" + spawnType.toString().toLowerCase());
    }  
    
    public Spawn(){
        
    }
    
    @Override
    public String[] getTypes(){
        String[] types = new String[SpawnType.values().length];
        int i=0;
        for(SpawnType p: SpawnType.values()){
            types[i] = this.getClass().getSimpleName().toLowerCase()+ "_" +p.toString().toLowerCase();
            i++;
        }
        return types;
    }
    
    @Override
    public Boolean getEffect(Sprite sprite, Score score){
        return true;
    }
    
    @Override
    public Boolean getEffect(Sprite sprite){
        return true;
    }
    
    @Override
    public String getSaveTypeBlock() {
        return this.getClass().getSimpleName().toLowerCase() + "_" + spawnType.toString().toLowerCase();
    }
    
    public void spawnSprite(Level lvl, int xi, int yi){
        pacx = xi;
        pacy = yi;
        level = lvl;
        spawnType.spawn();
    }
    
    public void spawnSprite(Level lvl, int xi, int yi, int ghostnumberi){
        ghostx = xi;
        ghosty = yi;
        ghostnumber = ghostnumberi;
        level = lvl;
        spawnType.spawn();
    }
    
    public void respawnSprite(){
        spawnType.spawn();
    }    
  
    private static void spawnGhost(){
        Ghost g = new Ghost(ghostx,ghosty,level,level.difficulty);
        Thread gt = new Thread(g);
        level.ghostThreads[ghostnumber] = gt;
        level.ghosts[ghostnumber] = g;        
    }
    
    private static void spawnPacMan(){
        PacMan pac = new PacMan(pacx,pacy);
        level.pacman = pac;
    }
    
    public enum SpawnType{
        GHOST { 
            @Override
            public void spawn(){
                spawnGhost();
                return;
        }},
        PACMAN { 
            @Override
            public void spawn(){
                spawnPacMan();
                return;
        }};        
        
        public abstract void spawn();       
    }
    
    public SpawnType spawnType;
    private static Level level;
    private static int pacx;
    private static int pacy;
    private static int ghostx;
    private static int ghosty;
    private static int ghostnumber;
}


