/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package game;

import block.MovingWall;
import gui.GUIGame;
import java.util.logging.Logger;
import main.Global;
import score.Score;

/**
 *
 * @author s070280
 */
public class Game implements Runnable {

    public Game(String levelName, GUIGame gInterface, String difficulti) {
        currentLevelName = levelName;
        gameInterface = gInterface;
        ingame = false;
        pause = false;
        difficulty = difficulti;
        score = new Score();        
        currentLevel = new Level(difficulty,score);
    }

    public void startGame() {
        currentLevel.initLevel(currentLevelName);
        currentLevel.setMovingWalls();
        currentLevel.setWarpHoles();
        currentLevel.createSprites();
        ingame = true;
        startTime = System.currentTimeMillis();
        if (currentLevel.ghostThreads.length !=0) {
            for (Thread tg : currentLevel.ghostThreads) {
                tg.start();
            }
        }
    }

    public void pauseGame() {
        pause = pause == true ? false : true;
        for(Ghost ghost: currentLevel.ghosts){
            ghost.setPause(pause);
        }        
    }

    public void endGame() {
        ingame = false;
    }

    public boolean isIngame() {
        return ingame;
    }

    public void moveSprites() {
        currentLevel.checkBite();
        currentLevel.pacman.checkCollision(currentLevel.levelArray, score);        
        currentLevel.pacman.move();
        for(Ghost ghost: currentLevel.ghosts){
            ghost.checkCollision(currentLevel.levelArray, score);
            ghost.move();
        }
    }

    public void goToNextLevel(String levelName) {
        currentLevel = new Level(difficulty, score);
        currentLevelName = levelName;
        startGame();
    }

    @Override
    public void run() {
        

        long beforeTime, timeDiff, sleepTime, excessTime;
        excessTime = 0;
        gameInterface.repaint();
        beforeTime = System.currentTimeMillis();
        while (ingame) {
            while (pause) {
                try {
                    Thread.sleep(100);
                    beforeTime = System.currentTimeMillis();
                } catch (InterruptedException ex) {
                    Logger.getLogger(Game.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
                }
            }
            moveSprites();            
            for (MovingWall mw : currentLevel.movingWallsTotal) {
                mw.animateWall();
            }
            
            currentTime = System.currentTimeMillis() - startTime;
            
            gameInterface.repaint();

            timeDiff = System.currentTimeMillis() - beforeTime;
            sleepTime = Global.FRAMETIME.value() - timeDiff - excessTime;


            if (sleepTime != 20) {
                System.out.print(sleepTime + "\n");
            }

            excessTime = 0;
            
            if (sleepTime >= 0) {
                try {
                    Thread.sleep(sleepTime);
                } catch (InterruptedException e) {
                    System.out.println("interrupted");
                }
            } else {
                excessTime -= sleepTime;
            }

            beforeTime = System.currentTimeMillis();

            while ((excessTime > Global.FRAMETIME.value())) {
                excessTime -= Global.FRAMETIME.value();
                moveSprites();
                for (MovingWall mw : currentLevel.movingWallsTotal) {
                    mw.animateWall();
                }
            }
            // check om te kijken of het level gehaald
            Boolean allPackdots = currentLevel.checkAllPacDotsEaten();
            if (allPackdots || currentLevel.lives == 0) { // levens moeten hier ook bij
                //currentTime = System.currentTimeMillis() - startTime;
                gameInterface.endGameHandler(allPackdots);
                //beforeTime = System.currentTimeMillis();
            }
        }


    }
    private GUIGame gameInterface;
    private String currentLevelName;
    public Level currentLevel;
    public boolean ingame;
    public Score score;
    public boolean pause;
    public String difficulty;
    
    private long startTime;
    public long currentTime;
}
