/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package game;

import java.awt.event.KeyEvent;
import main.Global;

/**
 * Pac-Man is the user controlled yellow hero.
 * @author Martin Pieck
 */
public class PacMan extends Sprite {

    public PacMan(int x, int y) {
        coordinate[0] = x;
        coordinate[1] = y;
        iconCount = 4;
        iconNr = 2;
        animationTotalTime = animationCycleTime = 5;
        setImage();
        speed = 0;
        pacState = State.DEFAULT;
    }

    public void setState(String state) {
        pacState = State.valueOf(state);
        stateModifier = pacState.speedModifier();
        stateTime = pacState.duration() * Global.TOTALFRAMESPERSEC.value();
        if (state.equals("SUPERMODE")) {
            level.setGhostsScared(true);
        }
    }

    @Override
    public void cycleState() {
        if (stateTime != -1) {
            stateTime--;
            if (stateTime == 150 && pacState == pacState.SUPERMODE) {
                level.setGhostsBlinking(true);
            }
            else if (stateTime == 0) {
                stateTime = -1;
                pacState = State.DEFAULT;
                level.setGhostsScared(false); 
                level.setGhostsBlinking(false);
                stateModifier = pacState.speedModifier();
                if(coordinate[0] % 2 !=0){
                    coordinate[0] += direction.getdX();
                }
                if(coordinate[1] % 2 !=0){
                    coordinate[1] += direction.getdY();
                }
            }
        }
    }

    public void keyPressed(KeyEvent e) {
        int key = e.getKeyCode();

        if (key == KeyEvent.VK_RIGHT) {
            changeDirection("right");
        }

        if (key == KeyEvent.VK_LEFT) {
            changeDirection("left");
        }
        if (key == KeyEvent.VK_UP) {
            changeDirection("up");
        }
        if (key == KeyEvent.VK_DOWN) {
            changeDirection("down");
        }
    }

    public enum State {

        DEFAULT(1.0, -1),
        TURBO(2.5, 5),
        SUPERMODE(1.5, 15),
        SWAMP(0.5, 5);
        private final double speedModifier;
        private final int duration;

        State(double speedMofifier, int duration) {
            this.speedModifier = speedMofifier;
            this.duration = duration;
        }

        public double speedModifier() {
            return speedModifier;
        }

        public int duration() {
            return duration;
        }
    }
    public State pacState;
    private int stateTime = -1;
}
