/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.awt.*;
import java.awt.event.*;
import java.awt.Color;

import javax.swing.*;
import javax.swing.JButton;
import javax.swing.border.Border;
import javax.swing.border.LineBorder;

import leveleditor.LevelEditor;
import block.Block;
import java.awt.GraphicsEnvironment;

/**
 *
 * @author s070280
 */

public class GUILevelEditor extends JPanel{
    
    public GUILevelEditor(GUIFrame f, GUIMainMenu mainMenu, String selectedlevel){
        setVisible(true);
        setLayout(null);
        frame = f;        
        menu = mainMenu;
        selectedLevel = selectedlevel; 
        
        lvlEditor = new LevelEditor();
        
        if (selectedLevel == null) {
            int[] dimensions = aksforDesiredLevelsize();
            lvlEditor.makeLevel(dimensions[0], dimensions[1]);    
        } else {
            lvlEditor.currentLevel.initLevel(selectedLevel);
        }
        
        Block[][] emptylevel = lvlEditor.getLevel();  
        drawField(emptylevel);
        
        menuButtons = lvlEditor.getavailableBlocklist();         
        createBlockButtons();                    

        frame.getContentPane().setPreferredSize(new Dimension(1280,800));
        frame.setLocation(GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint().x-640, GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint().y-400);        
        frame.pack();     
     
    } 
    
    @Override
    public void paintComponent(Graphics g) {
        g.drawImage(new ImageIcon(this.getClass().getResource("/img/leveleditor_background.png")).getImage(), 0, 0, null);
        
        back = new JButton(new ImageIcon(this.getClass().getResource("/img/returnleveleditor.png")));
        back.setBounds(75, 537, 100, 40); 
        back.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                setVisible(false);
                menu.setVisible(true);
                frame.getContentPane().setPreferredSize(new Dimension(640,480));
                frame.setLocation(GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint().x-300, GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint().y-200);        
                frame.pack(); 
            }
        });
        add(back);
        
        save = new JButton(new ImageIcon(this.getClass().getResource("/img/save.png")));
        save.setBounds(75, 580, 100, 40); 
        save.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                
                if ( lvlEditor.currentLevel.countBlocks("path_pacdot") > 0 && lvlEditor.currentLevel.countBlocks("spawn_pacman") > 0 && lvlEditor.currentLevel.countBlocks("path_powerpellet") > 0 && ( lvlEditor.currentLevel.countBlocks("warphole") == 0 || lvlEditor.currentLevel.countBlocks("warphole") == 2 )) {
                    String levelName = null;                
                    do {
                        levelName = aksforLevelname();
                    } while ( levelName.length() < 3 );
                    if (levelName != null && !levelName.startsWith("level")) {
                        lvlEditor.currentLevel.save(levelName);
                        setVisible(false);
                        menu.setVisible(true);
                        frame.getContentPane().setPreferredSize(new Dimension(640,480));
                        frame.setLocation(GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint().x-300, GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint().y-200);        
                        frame.pack();
                    } else {
                         JOptionPane.showMessageDialog(frame,
                        "Your levelstring was empty or starts with level. Your level is not saved.",
                        "Wrong Levelstring",
                        JOptionPane.PLAIN_MESSAGE);                    
                    }
                } else {
                    JOptionPane.showMessageDialog(frame,
                    "At least one pacdot, one powerpellet, one pacspawn and zero or two warpholes are required to play the level!",
                    "Wrong Level",
                    JOptionPane.PLAIN_MESSAGE);
                    //score afhandeling!! 
                }
            }
        });
        add(save);
    } 
    
    private int[] aksforDesiredLevelsize() {
        
        JTextField heightField = new JTextField();
        JTextField widthField = new JTextField();

        Object[] message = new Object[] { "Width [8 - 32]", heightField, "Height [8 - 20]", widthField };
        int[] dimensions = {0,0};
        do {
            int r = JOptionPane.showConfirmDialog(this, message, "Please enter the level size.", JOptionPane.OK_CANCEL_OPTION);
            if (r == JOptionPane.OK_OPTION) {
                dimensions[0] = Integer.parseInt(heightField.getText()); //height
                dimensions[1] = Integer.parseInt(widthField.getText());  //width
            }
        } while (dimensions[0] < 8 || dimensions[0] > 32 || dimensions[1] < 8 || dimensions[1] > 20); 
        return dimensions;
    }

    private String aksforLevelname() {
        String currentName = null;
        if (selectedLevel != null) { currentName = selectedLevel.toLowerCase(); }
        JTextField levelNameMsg = new JTextField(currentName);

        Object[] message = new Object[] { "Level Name", levelNameMsg };
        String levelName = null;
        int r = JOptionPane.showConfirmDialog(this, message, "Please enter the level name.", JOptionPane.OK_CANCEL_OPTION);
        if (r == JOptionPane.OK_OPTION) {
            levelName = levelNameMsg.getText();
        }
        return levelName;
    }
    
    private void createBlockButtons() {
        blockbtnz = new JButton[11];
        for(int i=0;i<5;i++){
            String btnName = "/img/block_" + menuButtons.get(i).toString() + ".png";
            blockbtnz[i] = new JButton(new ImageIcon(this.getClass().getResource(btnName)));
            blockbtnz[i].setBounds(78, 240 + i*50, 30, 30);
            blockbtnz[i].addActionListener(new SelectBlock());
            blockbtnz[i].setName(menuButtons.get(i).toString());
            blockbtnz[i].setBackground(Color.BLACK);
            this.add(blockbtnz[i]);
        }
       for(int i=5;i<blockbtnz.length-1;i++){
            String btnName = "/img/block_" + menuButtons.get(i).toString() + ".png";
            blockbtnz[i] = new JButton(new ImageIcon(this.getClass().getResource(btnName)));
            blockbtnz[i].setBounds(138, 240 + (i-5)*50, 30, 30);
            blockbtnz[i].addActionListener(new SelectBlock());
            blockbtnz[i].setName(menuButtons.get(i).toString());
            blockbtnz[i].setBackground(Color.BLACK);
            this.add(blockbtnz[i]);
        }
            String btnName = "/img/block_" + menuButtons.get(10).toString() + ".png";
            blockbtnz[10] = new JButton(new ImageIcon(this.getClass().getResource(btnName)));
            blockbtnz[10].setBounds(108, 240 + 250, 30, 30);
            blockbtnz[10].addActionListener(new SelectBlock());
            blockbtnz[10].setName(menuButtons.get(10).toString());
            blockbtnz[10].setBackground(Color.BLACK);
            Border thickBorder = new LineBorder(Color.RED, 2);
            blockbtnz[10].setBorder(thickBorder);
            this.add(blockbtnz[10]);
    }

    private void drawField(Block[][] emptylevel) {
        btnz = new JButton[emptylevel.length][emptylevel[0].length];
         for(int i=0;i<emptylevel.length;i++){
             for(int j=0;j<emptylevel[0].length;j++){
                Image btnImage = emptylevel[i][j].getImage();
                btnz[i][j] = new JButton(new ImageIcon(btnImage));
                btnz[i][j].setBounds(268 + j*30, 155 + i*30, 30, 30);
                btnz[i][j].addActionListener(new PlaceBlock());
                btnz[i][j].setName(Integer.toString(i) + ":" + Integer.toString(j));
                btnz[i][j].setBackground(Color.BLACK);
                this.add(btnz[i][j]);
             }
        }       
    }
    
    class ButtonListener implements ActionListener {
        
        @Override        
        public void actionPerformed(ActionEvent e) {
            JButton o = (JButton) e.getSource();
            String name = o.getName();

            if ("pacspawn".equals(name)) {
                //frame.add(new GUIGame());
                //setVisible(false);
            } else if ("ghostspawn".equals(name)) {
            }
            
        }
    }
    
    class SelectBlock implements ActionListener {
        
        @Override        
         public void actionPerformed(ActionEvent e){
            Border thickBorder = new LineBorder(Color.RED, 2);
            Border noborder = new LineBorder(Color.LIGHT_GRAY, 1);
           if( e.getSource() instanceof JButton) {
               //sets a red border on the selected block
               for (int i=0; i<blockbtnz.length; i++) {
                    blockbtnz[i].setBorder(noborder);   
               }
               ((JButton)e.getSource()).setBorder(thickBorder);
               String selectedblock = ((JButton)e.getSource()).getName();
               lvlEditor.selectType(selectedblock);
           }          
        }
    }
    
    class PlaceBlock implements ActionListener {
        
        @Override        
         public void actionPerformed(ActionEvent e) {
           if( e.getSource() instanceof JButton) {
               String selectedblock = ((JButton)e.getSource()).getName();
               //first look wich block in the maze is clicked
               String[] coords = selectedblock.split(":");
               int[] intcoords = {0,0};
               for (int i = 0; i < coords.length; i++) {
                    intcoords[i] = Integer.parseInt(coords[i]);
               }
               //then update the blockmatrix
               lvlEditor.placeBlock(intcoords);
               Block[][] emptylevel = lvlEditor.getLevel();
               //then update the icon for the user
               Image btnImage = emptylevel[intcoords[0]][intcoords[1]].getImage();
               btnz[intcoords[0]][intcoords[1]].setIcon(new ImageIcon(btnImage));
           }
        }
        
    }

    
    private GUIMainMenu menu;
    private JButton back;
    private JButton save;
    public GUIFrame frame;
    public JButton[] blockbtnz;
    public JButton[][] btnz;
    public LevelEditor lvlEditor;
    private List<String> menuButtons = new ArrayList<String>();
    private String selectedLevel;
}

