package gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FilenameFilter;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;



/**
 *
 * @author s070280
 */
public class GUILevelEditorSelect extends JPanel {

    public GUILevelEditorSelect(GUIFrame f, GUIMainMenu mainMenu) {
        setVisible(true);
        setLayout(null);
        frame = f;
        menu = mainMenu;
         
        back = new JButton(new ImageIcon(this.getClass().getResource("/img/return.png")));
        back.setBounds(20, 410, 290, 62);
        back.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                setVisible(false);
                menu.setVisible(true);
            }
        });
        add(back);
        
        select = new JButton(new ImageIcon(this.getClass().getResource("/img/leveleditor_selectlevel.png")));
        select.setBounds(330, 410, 290, 62); 
        select.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                frame.add(new GUILevelEditor(frame, menu, selectedLevel));
                setVisible(false);
            }
        });
        add(select);

        create = new JButton(new ImageIcon(this.getClass().getResource("/img/leveleditor_createlevel.png")));
        create.setBounds(180, 115, 290, 62);
        create.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                frame.add(new GUILevelEditor(frame, menu, null));
                setVisible(false);
            }
        });
        add(create);

        
        String[] fileList = getLevelfiles();
        selectedLevel = fileList[0];
        
        list = new JList(fileList);
        list.setBackground(Color.black);
        list.setForeground(Color.yellow);
        Font displayFont = new Font("Arial Black", Font.BOLD, 22);
        list.setFont(displayFont);
        list.addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(ListSelectionEvent e) {
               String levelName = (String) list.getSelectedValue();
               selectedLevel = levelName;
            }
        });

        pane = new JScrollPane(list);
        pane.setPreferredSize(new Dimension(290, 170));
        pane.setBounds(180, 225, 290, 170);
        pane.getViewport().setBackground(Color.BLACK);
        pane.setVisible(true);
        add(pane);     
   
    }
    
    private String[] getLevelfiles() {
        File f = new File("");        
        String dir = f.getAbsolutePath() + "/levels";
        f = new File(dir);
        FilenameFilter filter = new ExtenstionFilter("level");
        File[] files = f.listFiles(filter);
        String[] filenames = new String[files.length];
        String temp = null;
        for (int i =0; i < files.length; i++) {
            temp = files[i].getName().toUpperCase();
            filenames[i] = temp.substring(0, temp.indexOf("."));
        }
        return filenames;
    }

    private class ExtenstionFilter implements FilenameFilter {
        String ext;
        public ExtenstionFilter(String ext) {
            this.ext = "." + ext;
        }        

        public boolean accept(File dir, String name) {
            return name.endsWith(ext);
        }
    }


    public void paintComponent(Graphics g) {
        g.drawImage(new ImageIcon(this.getClass().getResource("/img/leveleditor_select.png")).getImage(), 0, 0, null);
    }
    private GUIMainMenu menu;
    private JButton back;
    private JButton create;
    private JButton select;
    public GUIFrame frame;
    private JList list;
    private JScrollPane pane;
    private String selectedLevel;
}
