/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package leveleditor;

import game.Level;
import block.*;
import java.util.ArrayList;
import java.util.Iterator;

/**
 *
 * @author s070280
 */
public class LevelEditor {

    public LevelEditor() {
        blockType = "warphole";
        blBuilder = new BlockBuilder();
        currentLevel = new Level("normal",null);
    }

    /**
     * This method calls createEmpty(int width, int height) to create a level filled with paths.
     * @param width
     * @param height
     */
    public void makeLevel(int height, int width) {        
        currentLevel.createEmpty(height, width);
    }

    /**
     * return the current levelmatrix.
     * @return 
     */
    public Block[][] getLevel() {
        return currentLevel.levelArray;
    }

    /**
     * this function returns a array of strings of all available block types. it uses the hashmap of blockbuilder.
     * @return 
     */
    public ArrayList<String> getavailableBlocklist() {
        //this function is not finished yet!!
        ArrayList<String> blocklist = new ArrayList<String>();
        //blocklist = new String[blBuilder.blocks.size()];
        Iterator iterator = blBuilder.blocks.keySet().iterator();
        int i = 0;
        try {
            while (iterator.hasNext()) {
                String blockClass = iterator.next().toString();
                Block b = (Block) blBuilder.blocks.get(blockClass).getConstructor().newInstance();
                String[] types = b.getTypes();
                if (types != null) {
                    for (String type : types) {
                        blocklist.add(type);
                        i++;
                    }
                } else {
                    blocklist.add(blockClass);
                    i++;
                }

            }
        } catch (Exception e) {
        }
        return blocklist;
    }

    /**
     * Sets blockType to value type.
     * @param type 
     */
    public void selectType(String type) {
        blockType = type;
    }

    /**
     * Places a block of type blockType at blocks[x][y] where (x,y) is represented by coordinate={x,y}.
     * @param coordinate 
     */
    public void placeBlock(int[] coordinates) {
        boolean changeallowed = false;
        
        // zorgt dat de walls aan de rand niet wegkunnen
        if (coordinates[0] != 0 && coordinates[1] != 0 && coordinates[0] != currentLevel.height - 1 && coordinates[1] != currentLevel.width - 1) {
            changeallowed = true;
        }
        
        // niet meer dan twee warpholes
        if (blockType.equals("warphole") && currentLevel.countBlocks("warphole") >= 2) {
            changeallowed = false;
        }
        
        // niet meer dan één pacspawn
        if (blockType.equals("spawn_pacman") && currentLevel.countBlocks("spawn_pacman") >= 1) {
            changeallowed = false;
        } 
        
        if (changeallowed == true) {
            currentLevel.levelArray[coordinates[0]][coordinates[1]] = blBuilder.getBlockfromString(blockType);
        }        

    }
    public Level currentLevel;
    private String blockType;
    private BlockBuilder blBuilder;
}
